;SERIELL_Labview1.a51 ********
;    mit Baudratengenerator 
;    Controller schickt bei Druck auf den Tasters P3.2 das mit den 8 Schaltern an P1 
;    eingestellte Byte mit 9600 Bit/s ber die serielle Schnittstelle 
;    Dieses Zeichen wird auch an P0 mit 8 LEDs dargestellt.
;    Ein empfangenes Byte wird an die 8 LEDs von P2 ausgegeben

		include C51ED2.inc
		code at 0

		Sendetaster 	Bit  P3.2	;Senden nach Druck auf diesen Taster 
		Sendebyte		data P1		;8 Schalter an P1 bilden das zu sendende Byte
		leds				data	P2

;*************** Reloadwert des Timers des TBaudratengenerators nur bei ED2 !!!!**********				
						;bei Quarz 12 MHz, 9600 Bps 
		reloadBRL	equ	217	; BRL = 256- ( 2^SMOD1 * Fper) / ( 6^(1-SPD) * 32 * Baudrate) 
										; Fper = Fquarz/2 = 6MHz wenn kein x2-Mode (bei X2-Mode Fper = 12 MHz)

;*************** Initialisierung serielle Schnittstelle *******************************

			orl	PCON,#10000000b		; SMOD=1 bei 9600 Baud
			mov	BRL,#reloadBRL			; Reloadwert fr int. Baudratengenerator
			mov	BDRCON,#00011110b		; int. Baudraten-Generator fr Senden und Empfangen, SPD=1
			mov	SCON,#01010000b 		; 8-Bit-UART, Empfang zulassen
			clr	ES							; kein serieller Interrupt

;**************************************************************************************
 			clr	ri							; Empfangsbit lschen: kein Zeichen empfangen
 			setb	ti							; Sendebit setzen: letzes Bit wurde gesendet
warteSenden:								
			jb		ri,empfang				; Byte abholen wenn eins empfangen wurde
			jnb	Sendetaster,warteSenden	;Warten bis Taster gedrckt
			
			mov	P0,sendebyte			; an LEDs ausgeben und
warteS: 	jnb   ti,warteS				; warten bis gesendet
senden:	mov   sbuf,Sendebyte			; Akkuinhalt senden
			clr   ti							; Sende-Flag lschen
			call	zeit						; Zeitverzgerung zur Tasterentprellung
warte2:	jb		Sendetaster,warte2	; warten bis Taster losgelassen, sonst werden mehrere zeichen gesendet
			lcall	zeit						; Zeitverzgerung zur Tasterentprellung
			sjmp	warteSenden				; von vorne

empfang:	mov P2,sbuf						; Zeichen ausgeben
			clr	ri							; Empfangsflag lschen
			sjmp	warteSenden				; von vorne

;********************** Unterprogramm Senden ******************************************


;********************** Unterprogramm Zeitverzgerung zur Entprellung *****************
zeit:		mov   r0,#0
zeit2:	mov   r1,#0				;	Zeitverzgerungskonstante
zeit1:	;djnz  r1,zeit1			;  256 x 256 x 2s
			djnz  r0,zeit2			;+ 256 x       2s
			ret			
end
